"use strict";
// @public

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mysql_config_1 = require("@databases/mysql-config");
const __1 = require("../");
const config = mysql_config_1.getMySqlConfigSync();
const DEFAULT_ENV_VAR = process.env.MYSQL_TEST_ENV_VAR || config.connectionStringEnvironmentVariable;
exports.killers = [];
function setup(opts = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const envVar = opts.environmentVariable || DEFAULT_ENV_VAR;
        const migrationsScript = opts.migrationsScript || (process.env.MYSQL_TEST_MIGRATIONS_SCRIPT ? process.env.MYSQL_TEST_MIGRATIONS_SCRIPT.split(' ') : config.test.migrationsScript);
        if (process.env[envVar]) {
            console.info(`Using existing mysql database from: ${envVar}`);
            return;
        }
        const { databaseURL, kill } = yield __1.default(opts);
        console.info(`Setting mysql connection string on environment: ${envVar}`);
        process.env[envVar] = databaseURL;
        if (migrationsScript) {
            console.info('Running mysql migrations');
            yield __1.run(migrationsScript[0], migrationsScript.slice(1), {
                debug: opts.debug || opts.debug === undefined && config.test.debug || false,
                name: migrationsScript.join(' ')
            });
        }
        exports.killers.push(() => __awaiter(this, void 0, void 0, function* () {
            delete process.env[envVar];
            yield kill();
        }));
    });
}
exports.default = setup;
module.exports = setup;
module.exports.default = setup;
module.exports.killers = exports.killers;
//# sourceMappingURL=globalSetup.js.map